#include <sicstus/sicstus.h>
/* ex_glue.h is generated by splfr from the foreign/[2,3] facts.
    Always include the glue header in your foreign resource code.
*/
#include "helper_tests_glue.h"
#include <mlpack/core.hpp>

// including helper functions for converting between arma structures and arrays
#include "helper.hpp"

SP_integer testing_Taking_Integer(SP_integer number)
{
    if (number == 1)
        return 1;
    else
        return 0;
}

SP_integer testing_Taking_Double(double number)
{
    if (number == 1.0)
        return 1;
    else
        return 0;
}

SP_integer testing_Taking_String(const char *string)
{
    if (strcmp(string, "true") == 0)
        return 1;
    else
        return 0;
}

SP_integer testing_Taking_Float_Vector(float *arr, SP_integer size)
{
    double compare[] = {1.0, 2.0, 3.0, 4.0, 5.0};
    for (size_t i = 0; i < size; i++)
    {
        if(compare[i] != arr[i])
            return 0;
    }

    vec compare2(5);
    for (double i = 0.0; i < size; i++)
    {
        compare2[i] = i + 1.0;
    }
    
    // convert the Prolog array to arma::rowvec
    vec arrVec = convertArrayToColvec(arr, size);

    for (size_t i = 0; i < size; i++)
    {
        if(compare2[i] != arrVec[i])
            return -1;
    }
    return 1;
}

SP_integer testing_Taking_Float_Matrix(float *arr, SP_integer size, SP_integer dataPointDim)
{
	// compares if the converted list is the same as an array
	double compare[] = {0.0, 1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0};
	for (size_t i = 0; i < size; i++)
	{
	    if(compare[i] != arr[i])
	        return 0;
	}
	// creates the mat for later comparision
    mat compareMat(dataPointDim,size/dataPointDim);
    for (double i = 0.0; i < 8; i++)
    {
        compareMat[i] = i;
    }

    // converts the given arr into a mat
    mat arrMat = convertArrayToMat(arr, size, dataPointDim);

    for (size_t i = 0; i < size; i++)
    {
        if(compareMat[i] != arrMat[i])
            return -1;
    }
    return 1;
}

SP_integer testing_Taking_Integer_Vector(SP_integer *arr, SP_integer size);
SP_integer testing_Taking_Integer_Matrix(SP_integer *arr, SP_integer cols, SP_integer rows);


void testing_Returning_Integer(SP_integer *number)
{
    *number = 1;
}
void testing_Returning_Double(double *number)
{
    *number = 1.0;
}
void testing_Returning_String(const char **str)
{
    *str = "true";
}
void testing_Returning_Float_Vector(float **arr, SP_integer *size)
{
    vec returnVector(5);
    for (double i = 0.0; i < 5; i++)
    {
        returnVector[i] = i;
    }

    returnVectorInformation(returnVector, arr, size);
}
void testing_Returning_Float_Matrix(float **arr, SP_integer *cols, SP_integer *rows)
{
    mat returnMat(2,4);
    for (double i = 0.0; i < 8; i++)
    {
        returnMat[i] = i;
    }

    returnMatrixInformation(returnMat, arr, cols, rows);
}
void testing_Returning_Integer_Vector(SP_integer **arr, SP_integer *size);
void testing_Returning_Integer_Matrix(SP_integer **arr, SP_integer *cols, SP_integer *rows);


void testing_Raising_SystemError(const char *message)
{
	raisePrologSystemExeption(message);
}

void testing_Raising_DomainError(const char *expectation, const char *culprit)
{
    if (strcmp(culprit, "string") == 0)
    {
        const char *string;
        raisePrologDomainExeption(string,2,expectation,"raising_DomainError");
    }
    else
    {
        float number;
        raisePrologDomainExeption(number,2,expectation,"raising_DomainError");
    }
}
