#include <sicstus/sicstus.h>
/* ex_glue.h is generated by splfr from the foreign/[2,3] facts.
   Always include the glue header in your foreign resource code.
*/
#include "emst_glue.h"
#include <mlpack/methods/emst/dtb.hpp>
#include <mlpack/core.hpp>

// including helper functions for converting between arma structures and arrays
#include "../../helper_files/helper.hpp"

// some of the most used namespaces
using namespace arma;
using namespace mlpack;
using namespace mlpack::emst;


// input:   const MatType & 	dataset,
//          const bool 	        naive = false,
//          const MetricType 	metric = MetricType(),
//          arma::mat & 	    results	<-
// output: 
// description:
//          Performs the MST calculation using the Dual-Tree Boruvka algorithm.
//
void emst(float *dataMatArr, SP_integer dataMatSize, SP_integer dataMatRowNum, SP_integer naive, float **resultsMatArr, SP_integer *resultsMatColNum, SP_integer *resultsMatRowNum)
{
    // convert the Prolog arrays to arma::mat
    mat data = convertArrayToMat(dataMatArr, dataMatSize, dataMatRowNum);

    // create the ReturnMat
    mat resultsReturnMat;
    
    
    try
    {
        DualTreeBoruvka(data, (naive == 1)).ComputeMST(resultsReturnMat);
    }
    catch(const std::exception& e)
    {
        raisePrologSystemExeption(e.what());
    }


    // return the Matrix
    returnMatrixInformation(resultsReturnMat, resultsMatArr, resultsMatColNum, resultsMatRowNum);
}