
:- module(emst, [emst/5]).

%% requirements of library(struct)
:- load_files(library(str_decl),
        [when(compile_time), if(changed)]).

%% needed for using the array type
:- use_module(library(structs)).
:- use_module('../../helper_files/helper.pl').

%% type definitions for the float array
:- foreign_type
        float32          = float_32,
        float_array      = array(float32).

%% definitions for the connected function


%% --Input--
%%              mat     dataset,
%%              bool    naive           => (1)true / (0)false
%%
%% --Output--
%%              mat     result
%%
%% --Description--
%%              Performs the MST calculation using the Dual-Tree Boruvka algorithm.
%%
emst(DataList, DataRows, Naive, ResultsList, YCols) :-
        convert_list_to_float_array(DataList, DataRows, array(Xsize, Xrows, X)),
        emstI(X, Xsize, Xrows, Naive, Y, YCols, YRows),
        convert_float_array_to_2d_list(Y, YCols, YRows, ResultsList).

foreign(emst, c, emstI(  +pointer(float_array), +integer, +integer, 
                        +integer, 
                        -pointer(float_array), -integer, -integer)).


%% Defines the functions that get connected from main.cpp
foreign_resource(emst, [emst]).

:- load_foreign_resource(emst).
