
:- module(emst_tests, [run_emst_tests/0]).

:- use_module(library(plunit)).

:- use_module(emst).
:- use_module('../../helper_files/helper.pl').


%%
%% TESTING predicate emst/5
%%
:- begin_tests(emst).      

%% Failure Tests
        

%% Successful Tests

test(emst_Direkt_Input_Use) :-
        emst([5.1,3.5,1.4,4.9,3.0,1.4,4.7,3.2,1.3,4.6,3.1,1.5], 3, 0, ResultsList, _),
        print(ResultsList),
        emst([5.1,3.5,1.4,4.9,3.0,1.4,4.7,3.2,1.3,4.6,3.1,1.5], 3, 0, [[2.0,3.0,0.24494902789592743],
                                                                       [1.0,2.0,0.30000022053718567],
                                                                       [0.0,2.0,0.5099020004272461]], _).
test(emst_Direkt_Input_Use_Naive) :-
        emst([5.1,3.5,1.4,4.9,3.0,1.4,4.7,3.2,1.3,4.6,3.1,1.5], 3, 1, ResultsList, _),
        print(ResultsList),
        emst([5.1,3.5,1.4,4.9,3.0,1.4,4.7,3.2,1.3,4.6,3.1,1.5], 3, 1, [[2.0,3.0,0.24494902789592743],
                                                                       [1.0,2.0,0.30000022053718567],
                                                                       [0.0,2.0,0.5099020004272461]], _).

test(emst_CSV_Input_Use) :-
        open('src/data_csv/iris2.csv', read, File),
        take_csv_row(File, skipFirstRow,10, Data),
        emst(Data, 4, 0, ResultsList, _),
        print(ResultsList),
        emst(Data, 4, 0, [[0.0,4.0,0.14142122864723206],
                          [0.0,7.0,0.17320498824119568],
                          [1.0,9.0,0.17320503294467926],
                          [2.0,3.0,0.24494902789592743],
                          [2.0,6.0,0.26457515358924866],
                          [3.0,8.0,0.29999974370002747],
                          [1.0,2.0,0.30000022053718567],
                          [7.0,9.0,0.3316626250743866],
                          [0.0,5.0,0.6164416074752808]], _).

:- end_tests(emst).


run_emst_tests :-
        run_tests.

