
:- module(mean_shift_tests, [run_mean_shift_tests/0]).

:- use_module(library(plunit)).

:- use_module(mean_shift).
:- use_module('../../helper_files/helper.pl').



%%
%% TESTING predicate meanShift/10
%%
:- begin_tests(meanShift).      

%% Failure Tests
                                            
test(mean_shift_Negative_MaxIterations, fail) :-
        meanShift(1, -1000, [5.1,3.5,1.4,4.9, 3.0,1.4,4.7,3.2, 1.3,4.6,3.1,1.5, 1.4,3.0,2.1,0.1],4, _, _, _, 0, 0).

%% doesnt cause an error
test(mean_shift_Too_Few_Data_Points) :-
        meanShift(1, 1000, [5.1,3.5,1.4,4.9],4, AssignList, CentroidsList, _, 0, 0),
        print('\nAssignments: '),
        print(AssignList),
        print('\nCentroids: '),
        print(CentroidsList).
        

%% Successful Tests

test(mean_shift_Normal_Use) :-
        meanShift(1, 1000, [5.1,3.5,1.4,4.9, 3.0,1.4,4.7,3.2, 1.3,4.6,3.1,1.5, 1.4,3.0,2.1,0.1],4, AssignList, CentroidsList, _, 0, 0),
        print('\nAssignments: '),
        print(AssignList),
        print('\nCentroids: '),
        print(CentroidsList).

test(mean_shift_CSV_Input) :-
        open('src/data_csv/iris2.csv', read, File),
        take_csv_row(File, skipFirstRow,10, Data),
        meanShift(0.5, 500, Data,4, AssignList, CentroidsList, _, 1, 1),
        print('\nAssignments: '),
        print(AssignList),
        print('\nCentroids: '),
        print(CentroidsList).

:- end_tests(meanShift).

run_mean_shift_tests :-
        run_tests.

