
:- module(nmf_tests, [run_nmf_tests/0]).

:- use_module(library(plunit)).

:- use_module(nmf).
:- use_module('../../helper_files/helper.pl').



%%
%% TESTING predicate nmf/10
%%
:- begin_tests(nmf).      

%% Failure Tests
                                            
test(nmf_Wrong_UpdateRule_Input, [error(domain_error('The given UpdateRule is unkown!' , wrongInput), _)]) :-
        nmf(wrongInput, 10000, 0.00001, [5.1,3.5,1.4,4.9,3.0,1.4,4.7,3.2,1.3,4.6,3.1,1.5], 3, 3, _, _, _, _).

test(nmf_Negative_MaxIterations, fail) :-
        nmf(multdist, -10000, 0.00001, [5.1,3.5,1.4,4.9,3.0,1.4,4.7,3.2,1.3,4.6,3.1,1.5], 3, 3, _, _, _, _).

test(nmf_Negative_MinResidue, fail) :-
        nmf(multdist, 10000, -0.00001, [5.1,3.5,1.4,4.9,3.0,1.4,4.7,3.2,1.3,4.6,3.1,1.5], 3, 3, _, _, _, _).

test(nmf_Negative_Rank, fail) :-
        nmf(multdist, 10000, 0.00001, [5.1,3.5,1.4,4.9,3.0,1.4,4.7,3.2,1.3,4.6,3.1,1.5], 3, -3, _, _, _, _).
        

%% Successful Tests

test(nmf_Multdist_High_Rank) :-
        nmf(multdist, 10000, 0.00001, [5.1,3.5,1.4,4.9,3.0,1.4,4.7,3.2,1.3,4.6,3.1,1.5], 3, 6, W, _, H, _),
        print('\nW: '),
        print(W),
        print('\nH: '),
        print(H).

test(nmf_Normal_Use_Multdist) :-
        nmf(multdist, 10000, 0.00001, [5.1,3.5,1.4,4.9,3.0,1.4,4.7,3.2,1.3,4.6,3.1,1.5], 3, 2, W, _, H, _),
        print('\nW: '),
        print(W),
        print('\nH: '),
        print(H).

test(nmf_Normal_Use_Multdiv) :-
        nmf(multdiv, 10000, 0.00001, [5.1,3.5,1.4,4.9,3.0,1.4,4.7,3.2,1.3,4.6,3.1,1.5], 3, 3, W, _, H, _),
        print('\nW: '),
        print(W),
        print('\nH: '),
        print(H).

test(nmf_Normal_Use_ALS) :-
        nmf(als, 10000, 0.00001, [5.1,3.5,1.4,4.9,3.0,1.4,4.7,3.2,1.3,4.6,3.1,1.5], 3, 3, W, _, H, _),
        print('\nW: '),
        print(W),
        print('\nH: '),
        print(H).

test(nmf_CSV_Input) :-
        open('src/data_csv/iris2.csv', read, File),
        take_csv_row(File, skipFirstRow,10, Data),
        nmf(multdist, 100, 0.00042, Data, 4, 2, W, _, H, _),
        print('\nW: '),
        print(W),
        print('\nH: '),
        print(H).

:- end_tests(nmf).

run_nmf_tests :-
        run_tests.

